;--------------------------------;
; Gigatron + LCD Nokia 3XXX.ASM  ;
;    84x48 dots;   PCD8544       ;
;          20.09.2020            ;
;                                ;
; 0FFH -  ...   ;
;--------------------------------;

;0123_HELLO!_2345
; I'm GIGATRON
;Press any key...

;  21 C8 06 13 20 0C - Init LCD ;
    ORG  0000H;
START:
    DB    08H, 00H;  LDA 00H
    DB    1AH, 0FFH; LD  AC,OUT - clear port -> /RES -  LCD;
;--------  LCD ---------------------
;       ,    RES "0".
;  RES        .
;  ,    !
;   RES 100 ns,  -  .
;   ( RES "0"->"1")    
LCD_RST:
;                        0 - SCLK    - 
;                       1 -- SDataIN -  /
;                      2 --- D/C     -  =1/=0
;                     3 ---- /SEL    -  LCD;
;                    4 ----- /RES    -  LCD;
;-------------
    DB    0EH, 0FFH; NOP - Delay
    DB    0EH, 0FFH; NOP - 20 mS
    DB    10H, 55H;  LD  $55,X
    DB    14H, 88H;  LD  $88,Y
;-------------
    DB    08H, 0F8H; LDA 0F8H   11111000b
    DB    1AH, 0FFH; LD  AC,OUT - port  -> RES
;-------------
    DB    10H, 20H;  LD  $20,X
    DB    0C6H,0FFH; LD  AC,[X]    
;-------------------------------------------------------------
    DB    08H, 80H;  LDA 80H   ""
    DB    0C2H,7FH;  STA [7FH] -  ""
    DB    08H, 0FFH; LDA 0FFH Test
;~~~~~~~~~~~~~~~~INIT LCD~~~~~~~~~~~~~~~~~~~~~;
;        21 C8 06 13 20 0C                    ;
;-------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RET21/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RET21/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;-------------
    DB    08H, 21H;  LDA 21H   
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_COM/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_COM/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
;-------------
RET21:
;-------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RETC8/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RETC8/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;-------------
    DB    08H, 0C8H;  LDA 0C8H   
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_COM/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_COM/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
;-------------
RETC8:
;-------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RET06/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RET06/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;-------------
    DB    08H, 06H;  LDA 06H   
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_COM/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_COM/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
;-------------
RET06:
;-------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RET13/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RET13/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;-------------
    DB    08H, 13H;  LDA 13H   
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_COM/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_COM/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
;-------------
RET13:
;-------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RET20/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RET20/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;-------------
    DB    08H, 20H;  LDA 20H   
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_COM/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_COM/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
;-------------
RET20:
;-------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RET0C/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RET0C/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;-------------
    DB    08H, 0CH;  LDA 0CH   
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_COM/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_COM/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
;-------------
    DB    0EH, 0A2H; NOP after JMP;
    DB    0EH, 0A2H; NOP after JMP;
RET0C:
;-------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RET40/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RET40/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;-------------
    DB    08H, 40H;  LDA 40H    Y;
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_COM/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_COM/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
;-------------
RET40:
;-------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RET80/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RET80/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;-------------
    DB    08H, 80H;  LDA 80H    ;
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_COM/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_COM/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
;====================================================================================
RET80:
;-------------        RAM ----
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RETTYT/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RETTYT/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;------------     : LCD_COM;
    DB    14H,(IMG_MOV/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(IMG_MOV/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
;-------------
RETTYT:
;/////////////////  ->  ///////////////////////////////////////////////////
;    DB    14H,(RET81/2/256)AND 0FFH; LD  RET81,Y; -   ( ) 
;    DB    0E0H,(RET81/2)AND 0FFH;   JMP  Y,RET81;   
;    DB    0EH, 0A2H; NOP after JMP;
;///////////////////////////////////////////////////////////////////////////////////////
;-------------      -----------------
    DB    08H, 00H;  LDA 00H - X;
    DB    0C2H,24H;  STA [24H]
    DB    08H, 01H;  LDA 00H - Y;
    DB    0C2H,25H;  STA [25H]
;-------------
    DB    08H, 0F8H; LDA 0F8H - counter Lo;
    DB    0C2H,26H;  STA [26H]
    DB    08H, 02H;  LDA 02H  - counter Hi;
    DB    0C2H,27H;  STA [27H]
CYCDAT:
;-------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RET55/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RET55/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;------------- Load code ---
    DB    01H, 24H;  LDA [24H] -  X -> AC
    DB    0C2H,24H;  STA [24H]
    DB    12H,0FFH;  LD  AC,X -   
    DB    84H, 01H;  ADD 01;    X 
    DB    0C2H,24H;  STA [24H]
    DB    0ECH,(INC_YPZ/2)AND 0FFH; BNE INC_YPZ;

    DB    01H, 25H;  LDA [25H] -  Y -> AC
    DB    0C2H,25H;  STA [25H]
    DB    84H, 01H;  ADD 01;    Y 
    DB    0C2H,25H;  STA [25H]
INC_YPZ:
    DB    01H, 25H;  LDA [25H] -  Y -> AC
    DB    0C2H,25H;  STA [25H]
    DB    16H,0FFH;  LD  AC,Y -   Y
    DB    0DH,0FFH;  LDA [Y,X]
    DB    0CEH,0FFH; STA [Y,X]
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_DAT/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_DAT/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
;-------------
RET55:
    DB    01H, 26H;  LDA [26H] -  counter Lo;
    DB    0C2H,26H;  STA [26H]
    DB    0A0H,01H;  SUB 01   -  
    DB    0C2H,26H;  STA [26H]
    DB    0ECH,(CYCDAT/2)AND 0FFH; BNE CYCDAT;
    DB    0EH, 0FDH; NOP after JMP

    DB    01H, 27H;  LDA [27H] -  counter Hi;
    DB    0C2H,27H;  STA [27H]
    DB    0A0H,01H;  SUB 01   -  
    DB    0C2H,27H;  STA [27H]
    DB    0ECH,(CYCDAT/2)AND 0FFH; BNE CYCDAT;
    DB    0EH, 0FDH; NOP after JMP

;------------- GET_KEY -----------------------------------
INP:
    DB    03H, 88H; LDA IN ; 0FFH - not pressed
    DB    0A0H,0FFH; SUB 0FFH
    DB    0EH, 0FFH; NOP
    DB    0F0H,(INP/2)AND 0FFH; BEQ INP; =0F0 =/=0ECH
    DB    0EH, 0FFH; NOP after JMP
    DB    14H, (POZ_XY/2/256)AND 0FFH;  LD  POZ_XY,Y;
    DB    0E0H,(POZ_XY/2)AND 0FFH;  JMP  Y,POZ_XY;
    DB    0EH, 0A2H; NOP after JMP
POZ_XY:
;-------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RET41/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RET41/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;-------------
    DB    08H, 40H;  LDA 40H   Y;
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_COM/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_COM/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
;-------------
RET41:
;-------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RET81/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RET81/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;-------------
    DB    08H, 80H;  LDA 80H   ;
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_COM/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_COM/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
;====================================================================================
RET81:
;-------------     -------------------------
    DB    08H, 15H;  LDA 15H -  21 b/w boxes;
    DB    0C2H,25H;  STA [25H]
BEG_BOX:
    DB    08H, 0CH;  LDA 0CH -  12 Byte;
    DB    0C2H,24H;  STA [24H]
;-------------
DOB_BOX:
;-------------      
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RETBLK/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RETBLK/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;------------- Load code ---
    DB    08H, 00H;  LDA 00H   Black
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_DAT/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_DAT/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
RETBLK:
    DB    01H, 24H;  LDA [24H] -   
    DB    0C2H,24H;  STA [24H]
    DB    0A0H,01H;  SUB 01   -  
    DB    0C2H,24H;  STA [24H]
    DB    0ECH,(DOB_BOX/2)AND 0FFH; BNE DOB_BOX;
    DB    0EH, 0A2H; NOP after JMP;
;------------
    DB    08H, 0CH;  LDA 0CH -  12 Byte;
    DB    0C2H,24H;  STA [24H]
;------------
DOW_BOX:
;-------------      
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    12H,0FFH;  LD  AC,X -   
    DB    08H,(RETWIT/2)AND 0FFH; LDA RETADDR<;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    90H, 01H;  ADD 01,X     
    DB    08H,(RETWIT/2/256)AND 0FFH; LDA >RETADDR;  A -   RETADDR
    DB    0C6H,0FFH; LD  AC,[X]       ""
;------------      ""
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    84H, 02H;  ADD 02;       82
    DB    0C2H,7FH;  STA [7FH] -  ""
;------------- Load code ---
    DB    08H, 0FFH;  LDA 00H   White
    DB    0C2H,21H;  STA [21H]   ..
;------------     : LCD_COM;
    DB    14H,(LCD_DAT/2/256)AND 0FFH; LD  LCD,Y; -   ( ) 
    DB    0E0H,(LCD_DAT/2)AND 0FFH;   JMP  Y,LCD;   
    DB    0EH, 0A2H; NOP after JMP;
RETWIT:
    DB    01H, 24H;  LDA [24H] -   
    DB    0C2H,24H;  STA [24H]
    DB    0A0H,01H;  SUB 01   -  
    DB    0C2H,24H;  STA [24H]
    DB    0ECH,(DOW_BOX/2)AND 0FFH; BNE DOB_BOX;
    DB    0EH, 0A2H; NOP after JMP;
;------------
    DB    01H, 25H;  LDA [25H] -    b/w 
    DB    0C2H,25H;  STA [25H]
    DB    0A0H,01H;  SUB 01   -  
    DB    0C2H,25H;  STA [24H]
    DB    0ECH,(BEG_BOX/2)AND 0FFH; BNE BEG_BOX;
    DB    0EH, 0A2H; NOP after JMP;

;------------- GET_KEY -----------------------------------
GET:
    DB    03H, 88H; LDA IN ; 0FFH - not pressed
    DB    0A0H,0FFH; SUB 0FFH
    DB    0EH, 0FFH; NOP
    DB    0F0H,(GET/2)AND 0FFH; BEQ INP; =0F0 =/=0ECH
    DB    0EH, 0FFH; NOP after JMP
    DB    14H, 00H;  LD  00H,Y
    DB    0E0H,00H;  JMP  Y,00H
    DB    0EH, 0A2H; NOP after JMP

;-------------
    ORG  0502H;
;                        0 - SCLK    - 
;                       1 -- SDataIN -  /
;                      2 --- D/C     -  =1/=0
;                     3 ---- /SEL    -  LCD;
LCD_COM:
    DB    01H, 20H;  LDA [20H] -   
    DB    0C2H,20H;  STA [20H] -   
    DB    4CH, 0F0H; ORA 0F0H = 1111.0000b
    DB    2CH, 0F7H; ANI 0F7H = 1111.0111b  -/SelCE
    DB    1AH, 0FFH; LD  AC,OUT -> port

    DB    2CH, 0FBH; ANI 0FBH = 1111.1011b  -/Cmd
    DB    1AH, 0FFH; LD  AC,OUT -> DAT/COM=0
    DB    0C2H,20H;  STA [20H] -   
;-------------
    DB    08H, 08H;  LDA 08H -    
    DB    0C2H,22H;  STA [22H] -  
ANA_BIT:
    DB    01H, 21H;  LDA [21H] -  
    DB    0C2H,21H;  STA [21H] -
    DB    2CH, 80H;  ANI 80H = 1000.0000b  _7
    DB    0ECH,(SET_PRC/2)AND 0FFH; BNE SET_PRC;   _7=1
    DB    0EH, 0FDH; NOP after JMP

    DB    01H, 20H;  LDA [20H] -   
    DB    0C2H,20H;  STA [20H]
    DB    4CH, 0F0H; ORA 0F0H = 1111.0000b
    DB    2CH, 0FDH; ANI 0FDH = 1111.1101b - DAT
    DB    0FCH,(SET_BIT/2)AND 0FFH;  BRA SET_BIT
    DB    0EH, 0FDH; NOP after JMP

SET_PRC:
    DB    01H, 20H;  LDA [20H] -   
    DB    0C2H,20H;  STA [20H] -   
    DB    4CH, 0F2H; ORA 0F2H = 1111.0010b - DAT
    DB    0FCH,(SET_BIT/2)AND 0FFH;  BRA SET_BIT
    DB    0EH, 0FDH; NOP after JMP

SET_BIT:
    DB    1AH, 0FFH; LD  AC,OUT
    DB    4CH, 0F1H; ORA 0F1H = 1111.0001b - STB
    DB    1AH, 0FFH; LD  AC,OUT
    DB    2CH, 0FEH; ANI 0FEH = 1111.1110b -/STB
    DB    1AH, 0FFH; LD  AC,OUT
    DB    0C2H,20H;  STA [20H] -   
;------------
    DB    01H, 21H;  LDA [21H] -  
    DB    0C2H,21H;  STA [21H]
    DB    86H, 0FFH; ADD  AC = RLC;
    DB    0C2H,21H;  STA [21H] -  AC*2
;------------
    DB    01H, 22H;  LDA [22H] -  
    DB    0C2H,22H;  STA [22H]
    DB    0A0H,01H;  SUB 01   -  
    DB    0C2H,22H;  STA [22H]
    DB    0ECH,(ANA_BIT/2)AND 0FFH; BNE ANA_BIT;
    DB    0EH, 0FDH; NOP after JMP
;------------
    DB    01H, 20H;  LDA [20H] -   
    DB    0C2H,20H;  STA [20H] -   
    DB    4CH, 0F8H; ORA 0F8H = 1111.1000b
    DB    0C2H,20H;  STA [20H] -   
    DB    1AH, 0FFH; LD  AC,OUT -   
EXIT:
;------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    0B0H,01H;  SUB 01,X;     

    DB    05H,0FFH;  LDA [X];      ""  
    DB    0C6H,0FFH; LD  AC,[X] 
    DB    16H,0FFH;  LD  AC,Y;      

    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    0B0H,02H;  SUB 02,X -    

    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    0A0H,02H;  SUB 02   -      80
    DB    0C2H,7FH;  STA [7FH] -   ""

    DB    05H,0FFH;  LDA [X];      ""  
    DB    0C6H,0FFH; LD  AC,[X] 
    DB    0E2H,5FH;  JMP  Y,AC;      RETA
    DB    0EH, 0FDH; NOP after JMP

;-------------
    ORG  0602H;
;                        0 - SCLK    - 
;                       1 -- SDataIN -  /
;                      2 --- D/C     -  =1/=0
;                     3 ---- /SEL    -  LCD;
LCD_DAT:
    DB    01H, 20H;  LDA [20H] -   
    DB    0C2H,20H;  STA [20H] -   
    DB    4CH, 0F0H; ORA 0F0H = 1111.0000b
    DB    2CH, 0F7H; ANI 0F7H = 1111.0111b  -/SelCE
    DB    1AH, 0FFH; LD  AC,OUT -> port

    DB    4CH, 04H;  ORA 04H = 0000.0100b  - =1
    DB    1AH, 0FFH; LD  AC,OUT -> DAT/COM=0
    DB    0C2H,20H;  STA [20H] -   
;-------------
    DB    08H, 08H;  LDA 08H -    
    DB    0C2H,22H;  STA [22H] -  
ANL_BIT:
    DB    01H, 21H;  LDA [21H] -  
    DB    0C2H,21H;  STA [21H] -
    DB    2CH, 80H;  ANI 80H = 1000.0000b  _7
    DB    0ECH,(PSC_SET/2)AND 0FFH; BNE SET_PRC;   _7=1
    DB    0EH, 0FDH; NOP after JMP

    DB    01H, 20H;  LDA [20H] -   
    DB    0C2H,20H;  STA [20H]
    DB    4CH, 0F0H; ORA 0F0H = 1111.0000b
    DB    2CH, 0FDH; ANI 0FDH = 1111.1101b - DAT
    DB    0FCH,(BIT_SET/2)AND 0FFH;  BRA SET_BIT
    DB    0EH, 0FDH; NOP after JMP

PSC_SET:
    DB    01H, 20H;  LDA [20H] -   
    DB    0C2H,20H;  STA [20H] -   
    DB    4CH, 0F2H; ORA 0F2H = 1111.0010b - DAT
    DB    0FCH,(BIT_SET/2)AND 0FFH;  BRA SET_BIT
    DB    0EH, 0FDH; NOP after JMP

BIT_SET:
    DB    1AH, 0FFH; LD  AC,OUT
    DB    4CH, 0F1H; ORA 0F1H = 1111.0001b - STB
    DB    1AH, 0FFH; LD  AC,OUT
    DB    2CH, 0FEH; ANI 0FEH = 1111.1110b -/STB
    DB    1AH, 0FFH; LD  AC,OUT
    DB    0C2H,20H;  STA [20H] -   
;------------
    DB    01H, 21H;  LDA [21H] -  
    DB    0C2H,21H;  STA [21H]
    DB    86H, 0FFH; ADD  AC = RLC;
    DB    0C2H,21H;  STA [21H] -  AC*2
;------------
    DB    01H, 22H;  LDA [22H] -  
    DB    0C2H,22H;  STA [22H]
    DB    0A0H,01H;  SUB 01   -  
    DB    0C2H,22H;  STA [22H]
    DB    0ECH,(ANL_BIT/2)AND 0FFH; BNE ANL_BIT;
    DB    0EH, 0FDH; NOP after JMP
;------------
    DB    01H, 20H;  LDA [20H] -   
    DB    0C2H,20H;  STA [20H] -   
    DB    4CH, 0F8H; ORA 0F8H = 1111.1000b
    DB    0C2H,20H;  STA [20H] -   
    DB    1AH, 0FFH; LD  AC,OUT -   
QUIT:
;------------    
    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    0B0H,01H;  SUB 01,X;     

    DB    05H,0FFH;  LDA [X];      ""  
    DB    0C6H,0FFH; LD  AC,[X] 
    DB    16H,0FFH;  LD  AC,Y;      

    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    0B0H,02H;  SUB 02,X -    

    DB    01H, 7FH;  LDA [7FH] -    ""
    DB    0C2H,7FH;  STA [7FH]
    DB    0A0H,02H;  SUB 02   -      80
    DB    0C2H,7FH;  STA [7FH] -   ""

    DB    05H,0FFH;  LDA [X];      ""  
    DB    0C6H,0FFH; LD  AC,[X]  
    DB    0E2H,5FH;  JMP  Y,AC;      RETA
    DB    0EH, 0FDH; NOP after JMP

;------------- 84 * 6 = 504 (1F8H)    ----------
IMG_MOV:
    DB    14H,  01H;  LD  01H,Y -   ( )
    DB    10H,  0FFH; LD  0FFH,X -  
;-------------
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH, 2AH; ST  2AH,[Y,X++]
    DB    0DCH, 15H; ST  15H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 85H; ST  85H,[Y,X++]
    DB    0DCH,0E2H; ST 0E2H,[Y,X++]
    DB    0DCH, 65H; ST  65H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 85H; ST  85H,[Y,X++]
    DB    0DCH,0E2H; ST 0E2H,[Y,X++]
    DB    0DCH, 65H; ST  65H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 85H; ST  85H,[Y,X++]
    DB    0DCH, 82H; ST  82H,[Y,X++]
    DB    0DCH, 85H; ST  85H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 82H; ST  82H,[Y,X++]
    DB    0DCH,0E5H; ST 0E5H,[Y,X++]
    DB    0DCH, 62H; ST  62H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 85H; ST  85H,[Y,X++]
    DB    0DCH,0E2H; ST 0E2H,[Y,X++]
    DB    0DCH, 65H; ST  65H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 85H; ST  85H,[Y,X++]
    DB    0DCH, 82H; ST  82H,[Y,X++]
    DB    0DCH, 85H; ST  85H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 82H; ST  82H,[Y,X++]
    DB    0DCH,0F5H; ST 0F5H,[Y,X++]
    DB    0DCH, 72H; ST  72H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 15H; ST  15H,[Y,X++]
    DB    0DCH, 2AH; ST  2AH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0A0H; ST 0A0H,[Y,X++]
    DB    0DCH, 40H; ST  40H,[Y,X++]
    DB    0DCH, 80H; ST  80H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 60H; ST  60H,[Y,X++]
    DB    0DCH, 7CH; ST  7CH,[Y,X++]
    DB    0DCH, 1FH; ST  1FH,[Y,X++]
    DB    0DCH, 03H; ST  03H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 62H; ST  62H,[Y,X++]
    DB    0DCH, 7EH; ST  7EH,[Y,X++]
    DB    0DCH, 1FH; ST  1FH,[Y,X++]
    DB    0DCH, 03H; ST  03H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 3CH; ST  3CH,[Y,X++]
    DB    0DCH, 7EH; ST  7EH,[Y,X++]
    DB    0DCH, 4BH; ST  4BH,[Y,X++]
    DB    0DCH, 49H; ST  49H,[Y,X++]
    DB    0DCH, 68H; ST  68H,[Y,X++]
    DB    0DCH, 2FH; ST  2FH,[Y,X++]
    DB    0DCH, 07H; ST  07H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 70H; ST  70H,[Y,X++]
    DB    0DCH, 7CH; ST  7CH,[Y,X++]
    DB    0DCH, 1FH; ST  1FH,[Y,X++]
    DB    0DCH, 03H; ST  03H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 70H; ST  70H,[Y,X++]
    DB    0DCH, 7CH; ST  7CH,[Y,X++]
    DB    0DCH, 1FH; ST  1FH,[Y,X++]
    DB    0DCH, 03H; ST  03H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 38H; ST  38H,[Y,X++]
    DB    0DCH, 7EH; ST  7EH,[Y,X++]
    DB    0DCH, 43H; ST  43H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 78H; ST  78H,[Y,X++]
    DB    0DCH, 3FH; ST  3FH,[Y,X++]
    DB    0DCH, 07H; ST  07H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 60H; ST  60H,[Y,X++]
    DB    0DCH, 6CH; ST  6CH,[Y,X++]
    DB    0DCH, 0FH; ST  0FH,[Y,X++]
    DB    0DCH, 03H; ST  03H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 80H; ST  80H,[Y,X++]
    DB    0DCH, 40H; ST  40H,[Y,X++]
    DB    0DCH,0A0H; ST 0A0H,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH,0AAH; ST 0AAH,[Y,X++]
    DB    0DCH, 55H; ST  55H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 04H; ST  04H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH,0FFH; ST 0FFH,[Y,X++]
    DB    0DCH,0FFH; ST 0FFH,[Y,X++]
    DB    14H,  02H; LD  02H,Y -   ( )
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 0CH; ST  0CH,[Y,X++]
    DB    0DCH, 0FH; ST  0FH,[Y,X++]
    DB    0DCH, 03H; ST  03H,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH,0F8H; ST 0F8H,[Y,X++]
    DB    0DCH,0F8H; ST 0F8H,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH,0F8H; ST 0F8H,[Y,X++]
    DB    0DCH,0F0H; ST 0F0H,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH,0F8H; ST 0F8H,[Y,X++]
    DB    0DCH,0F0H; ST 0F0H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 7CH; ST  7CH,[Y,X++]
    DB    0DCH,0FEH; ST 0FEH,[Y,X++]
    DB    0DCH, 83H; ST  83H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 21H; ST  21H,[Y,X++]
    DB    0DCH,0E2H; ST 0E2H,[Y,X++]
    DB    0DCH,0E7H; ST 0E7H,[Y,X++]
    DB    0DCH, 20H; ST  20H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH,0FFH; ST 0FFH,[Y,X++]
    DB    0DCH,0FFH; ST 0FFH,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 7CH; ST  7CH,[Y,X++]
    DB    0DCH,0FEH; ST 0FEH,[Y,X++]
    DB    0DCH, 83H; ST  83H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 21H; ST  21H,[Y,X++]
    DB    0DCH,0E2H; ST 0E2H,[Y,X++]
    DB    0DCH,0E7H; ST 0E7H,[Y,X++]
    DB    0DCH, 20H; ST  20H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH,0C0H; ST 0C0H,[Y,X++]
    DB    0DCH, 38H; ST  38H,[Y,X++]
    DB    0DCH, 26H; ST  26H,[Y,X++]
    DB    0DCH, 3FH; ST  3FH,[Y,X++]
    DB    0DCH,0F8H; ST 0F8H,[Y,X++]
    DB    0DCH,0C0H; ST 0C0H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 03H; ST  03H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH,0FFH; ST 0FFH,[Y,X++]
    DB    0DCH,0FFH; ST 0FFH,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 03H; ST  03H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH,0FFH; ST 0FFH,[Y,X++]
    DB    0DCH,0FFH; ST 0FFH,[Y,X++]
    DB    0DCH, 11H; ST  11H,[Y,X++]
    DB    0DCH, 71H; ST  71H,[Y,X++]
    DB    0DCH,0EFH; ST 0EFH,[Y,X++]
    DB    0DCH, 8EH; ST  8EH,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 7CH; ST  7CH,[Y,X++]
    DB    0DCH,0FEH; ST 0FEH,[Y,X++]
    DB    0DCH, 83H; ST  83H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 83H; ST  83H,[Y,X++]
    DB    0DCH,0FEH; ST 0FEH,[Y,X++]
    DB    0DCH, 7CH; ST  7CH,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH,0FFH; ST 0FFH,[Y,X++]
    DB    0DCH, 03H; ST  03H,[Y,X++]
    DB    0DCH, 06H; ST  06H,[Y,X++]
    DB    0DCH, 1CH; ST  1CH,[Y,X++]
    DB    0DCH, 38H; ST  38H,[Y,X++]
    DB    0DCH,0E1H; ST 0E1H,[Y,X++]
    DB    0DCH,0FFH; ST 0FFH,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 40H; ST  40H,[Y,X++]
    DB    0DCH,0C0H; ST 0C0H,[Y,X++]
    DB    0DCH, 80H; ST  80H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 81H; ST  81H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH,0C1H; ST 0C1H,[Y,X++]
    DB    0DCH, 80H; ST  80H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH,0C1H; ST 0C1H,[Y,X++]
    DB    0DCH, 81H; ST  81H,[Y,X++]
    DB    0DCH, 40H; ST  40H,[Y,X++]
    DB    0DCH, 40H; ST  40H,[Y,X++]
    DB    0DCH, 80H; ST  80H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 81H; ST  81H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH,0C1H; ST 0C1H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 80H; ST  80H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH,0C1H; ST 0C1H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 80H; ST  80H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 81H; ST  81H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 40H; ST  40H,[Y,X++]
    DB    0DCH,0C1H; ST 0C1H,[Y,X++]
    DB    0DCH, 81H; ST  81H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 80H; ST  80H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH,0C1H; ST 0C1H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH,0C1H; ST 0C1H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 09H; ST  09H,[Y,X++]
    DB    0DCH,0F9H; ST 0F9H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH,0C0H; ST 0C0H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 81H; ST  81H,[Y,X++]
    DB    0DCH, 40H; ST  40H,[Y,X++]
    DB    0DCH, 40H; ST  40H,[Y,X++]
    DB    0DCH, 80H; ST  80H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH,0C1H; ST 0C1H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 40H; ST  40H,[Y,X++]
    DB    0DCH,0C0H; ST 0C0H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 01H; ST  01H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 40H; ST  40H,[Y,X++]
    DB    0DCH, 7FH; ST  7FH,[Y,X++]
    DB    0DCH, 44H; ST  44H,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 07H; ST  07H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 0FH; ST  0FH,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 07H; ST  07H,[Y,X++]
    DB    0DCH, 09H; ST  09H,[Y,X++]
    DB    0DCH, 09H; ST  09H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 0DH; ST  0DH,[Y,X++]
    DB    0DCH, 09H; ST  09H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 06H; ST  06H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 0DH; ST  0DH,[Y,X++]
    DB    0DCH, 09H; ST  09H,[Y,X++]
    DB    0DCH, 0AH; ST  0AH,[Y,X++]
    DB    0DCH, 06H; ST  06H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 06H; ST  06H,[Y,X++]
    DB    0DCH, 09H; ST  09H,[Y,X++]
    DB    0DCH, 09H; ST  09H,[Y,X++]
    DB    0DCH, 0FH; ST  0FH,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 0FH; ST  0FH,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 0FH; ST  0FH,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 40H; ST  40H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 26H; ST  26H,[Y,X++]
    DB    0DCH, 18H; ST  18H,[Y,X++]
    DB    0DCH, 07H; ST  07H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 0FH; ST  0FH,[Y,X++]
    DB    0DCH, 09H; ST  09H,[Y,X++]
    DB    0DCH, 02H; ST  02H,[Y,X++]
    DB    0DCH, 0CH; ST  0CH,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 07H; ST  07H,[Y,X++]
    DB    0DCH, 09H; ST  09H,[Y,X++]
    DB    0DCH, 09H; ST  09H,[Y,X++]
    DB    0DCH, 05H; ST  05H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 40H; ST  40H,[Y,X++]
    DB    0DCH, 41H; ST  41H,[Y,X++]
    DB    0DCH, 26H; ST  26H,[Y,X++]
    DB    0DCH, 18H; ST  18H,[Y,X++]
    DB    0DCH, 07H; ST  07H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 08H; ST  08H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
    DB    0DCH, 00H; ST  00H,[Y,X++]
;-------------
    DB    14H,(QUIT/2/256)AND 0FFH; LD  QUIT,Y; -   ( ) 
    DB    0E0H,(QUIT/2)AND 0FFH;   JMP  Y,QUIT;   
    DB    0EH, 0A2H; NOP after JMP;
;-------------
INN:
    DB    0FCH,(INP/2)AND 0FFH;  BRA INN
    DB    0EH, 0FDH; NOP after JMP
FIN:
    DB    0ECH,(FIN/2)AND 0FFH;  BEQ FIN;
    DB    0EH, 0A2H; NOP after JMP
;-------------
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;
    DB    01H, 0FFH;

    END
;---------------------------------------